﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.IO;
using System.Runtime.InteropServices;


namespace Aproksymacja_3D
{
    public partial class Okno : Form
    {

        //***INTERPOLACJA***
        
        [DllImport("aproks_dll.dll")]
	    static extern string Result(string s,int n, int m);

        //***WIZUALIZACJA 3D***
        [DllImport("vis3d.dll")]
        static extern int Init(int hwnd, int w, int h, double vangle, double minz);

        [DllImport("vis3d.dll")]
        static extern int SetData(string d, int n);

        [DllImport("vis3d.dll")]
        static extern void Draw(int n, int[] f, int[] c, int bc);

        [DllImport("vis3d.dll")]
        static extern void ChangeState(double tx, double ty, double tz, double tax, double tay, double taz);

        /****/

        const int DELTA_RESIZE_Y=200;
        int defaulth, defaultdh,defaultth;
	
           public Okno()
        {
            InitializeComponent();
            this.tabPage2.MouseMove += new System.Windows.Forms.MouseEventHandler(this.tabPage2_mouseMove);
            this.tabPage2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.tabPage2_onClick);
            this.tabPage2.MouseUp += new System.Windows.Forms.MouseEventHandler(this.tabPage2_offClick);
            defaulth = Height;
            defaultdh = data.Height;
            defaultth = zakladka.Height;
        }

        private void wynik_Click(object sender, EventArgs e)
        {
            try
            {

                if (Height < 400)
                {
                    Height += DELTA_RESIZE_Y;
                    data.Height += DELTA_RESIZE_Y;
                    zakladka.Height += DELTA_RESIZE_Y;
                }
                data.Rows.Clear();

                string rawdata = Result(funkcja.Text, (int)npoints.Value, (int)mpoints.Value);
                Init((int)tabPage2.Handle, tabPage2.Width, tabPage2.Height, 90, 0.01);
                SetData(rawdata, 4);

                rawdata = rawdata.Remove(rawdata.Length - 1);
                string[] rows = rawdata.Split('\n');
                foreach (string rowa in rows)
                {
                    string[] cols = rowa.Split(' ');
                    int index = data.Rows.Add(cols);
                    data.Rows[index].HeaderCell.Value = index.ToString();
                }

                if (!funkcja.Items.Contains(funkcja.Text))
                funkcja.Items.Insert(0,funkcja.Text);

                //string[] row = new string[6];

            }

            catch (DllNotFoundException ex)
            {
                System.Windows.Forms.MessageBox.Show("Brak biblioteki dll:\n" + ex.ToString(), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (EntryPointNotFoundException ex)
            {
                System.Windows.Forms.MessageBox.Show("Brak biblioteki dll:\n" + ex.ToString(), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (FormatException)
            {
                System.Windows.Forms.MessageBox.Show("Nieprawidlowy format danych!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (DivideByZeroException)
            {
                System.Windows.Forms.MessageBox.Show("Niepoprawne dane!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void Okno_Load(object sender, EventArgs e)
        {
            funkcja.Text = "sin(x)+cos(y)";
            funkcja.Items.Add("sin(x)+cos(y)");
        }

        private void oProgramieToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Aproksymacja średniokwadratowa ciągła na obszarze [0,1]x[0,1] w bazie funkcji 1, x, y, xy.\nCałkowanie złożonymi formułami trapezów.\nWersja: 1.0\nProgram napisał Kamil Korolkiewicz\nStrona www: http://kk.plenty.vbiz.pl",
                "O programie",MessageBoxButtons.OK,MessageBoxIcon.Information);
        }

        private void wyjdźToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void wyczyśćWynikiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            data.Rows.Clear();
            Height = defaulth;
            data.Height = defaultdh;
            zakladka.Height = defaultth;
        }

        private void wczytajToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*wczytuje dane z pliku w kolejnosci:
             * wzor funkcji
             * n
             * m
             */
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.InitialDirectory = ".";
            ofd.Filter = "Pliki tekstowe (*.txt)|*.txt|Wszystkie pliki (*.*)|*.*";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    Stream _str = ofd.OpenFile();
                    StreamReader str = new StreamReader(_str);
                    funkcja.Text=str.ReadLine();
 
                    npoints.Value = Convert.ToInt32(str.ReadLine());
                    mpoints.Value = Convert.ToInt32(str.ReadLine());
                    str.Close();

                    wynik_Click(sender, e);

                }
                catch (Exception ex)
                {
                    MessageBox.Show("Błąd przy wczytywaniu pliku:\n" + ex.Message,"Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                }

            }

        }

        private void Rysuj()
        {
            Init((int)tabPage2.Handle, tabPage2.Width, tabPage2.Height, 90, 0.01);
            int[] c = new int[4];
            int[] f = new int[4];
            int nf = 0;
            if (pokazujFxyToolStripMenuItem.Checked)
            {
                c[nf] = 256 * 256 * 256 - 1;
                f[nf++] = 0;
            }
            if (pokazujwxyToolStripMenuItem.Checked)
            {
                c[nf] = 255 << 16;
                f[nf++] = 1;
            }
            if (pokazujbledyMenuItem.Checked)
            {
                c[nf] = 255;
                f[nf++] = 2;
            }
            if (pokazujbledy2MenuItem.Checked)
            {
                c[nf] = 255<<8;
                f[nf++] = 3;
            }

            Draw(nf, f, c, 0);
        }

        private void drawviz(object sender, PaintEventArgs e)
        {
            //Height = defaulth;
            //data.Height = defaultdh;
            //zakladka.Height = defaultth;
            Rysuj();
        }

        int prevcursorx, prevcursory;
        private void tabPage2_onClick(object sender, MouseEventArgs e)
        {
            if (e.Button != System.Windows.Forms.MouseButtons.Middle)
                tabPage2.Cursor = System.Windows.Forms.Cursors.SizeAll;
            else
                tabPage2.Cursor = System.Windows.Forms.Cursors.SizeNS;

            prevcursorx = e.X;
            prevcursory = e.Y;
        }

        private void tabPage2_offClick(object sender, EventArgs e)
        {
            tabPage2.Cursor = System.Windows.Forms.Cursors.Default;
        }

        private void tabPage2_mouseMove(object sender, MouseEventArgs e)
        {
            if (tabPage2.Cursor != System.Windows.Forms.Cursors.Default)
            {
                double dx = e.X - prevcursorx;
                double dy = e.Y - prevcursory;
                if (e.Button == System.Windows.Forms.MouseButtons.Left)
                {
                    ChangeState(-dx / 100, dy / 100, 0, 0, 0, 0);
                }
                if (e.Button == System.Windows.Forms.MouseButtons.Middle)
                {
                    ChangeState(0, 0, -dy / 100, 0, 0, 0);
                }
                if (e.Button == System.Windows.Forms.MouseButtons.Right)
                {
                    ChangeState(0, 0, 0, -dx / 100, 0, -dy / 100);
                }

                Rysuj();

                prevcursorx = e.X;
                prevcursory = e.Y;
            }
        }

        private void pokazujFxyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Rysuj();
        }

        private void pokazujwxyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Rysuj();
        }

        private void pokazujbledyMenuItem_Click(object sender, EventArgs e)
        {
            Rysuj();
        }

        private void pokazujbledy2MenuItem_Click(object sender, EventArgs e)
        {
            Rysuj();
        }

    }
}
