#include <cstring>
#include <cstdio>
#include <cstdlib>

#include "dquad.h"
#include "feval/eval.h"
#include "apr.h"
#include "err.h"

#define N 4

double wsp_tab[N]; //1, x, y, xy
//double gramm[N]={1,1./2,1./2.,1./9.};
double gramm_rev[N][N]=
{	{ 1.0000,   -1.5000,   -1.5000,    2.2500},
	{-1.5000,    3.0000,    2.2500,   -4.5000},
	{-1.5000,    2.2500,    3.0000,   -4.5000},
	{ 2.2500,   -4.5000,   -4.5000,    9.0000},
};

double g0(double x,double y) {return 1;}
double g1(double x,double y) {return x;}
double g2(double x,double y) {return y;}
double g3(double x,double y) {return x*y;}

double (*g[N])(double x,double y)={g0,g1,g2,g3};

void apr_init_f(const char *f,int n)
{
	double pom_tab[N];
	for (int i=0; i<N; i++)
	{
		pom_tab[i]=dblquad(f,g[i],0,1,0,1,n);
	}
	for (int j=0; j<N; j++)
	{
		double sum=0;
		for (int i=0; i<N; i++) sum+=16*gramm_rev[j][i]*pom_tab[i];

		wsp_tab[j]=sum;
	}
}

double apr_eval(double x,double y)
{

	double sum=0;

	for (int i=0; i<N; i++)
	{
		sum+=wsp_tab[i]*g[i](x,y);
	}

	return sum;
}

char *buf=0;

#define LINESIZE 1024

const char *apr_res(const char *fstr,int n,int m)
{
	if (buf) delete[] buf;
	//szacujemy rozmiar bufora
	buf=new char[m*m*LINESIZE];
	buf[0]=0;

	char line[LINESIZE];

	apr_init_f(fstr,n);

	CEval<double> f;
	f.AddVar("x",0);
	f.AddVar("y",0);
	double *x,*y;
	x=f.GetVarPtr("x");
	y=f.GetVarPtr("y");

	m--;

	f.Set(fstr);

	double dx=1./m;
	double dy=1./m;

	*y=0;
	for (int i=0; i<=m; i++)
	{
		*x=0;
		for (int j=0; j<=m; j++)
		{
			double fv=f();
			if (IS_INV(fv)) fv=0;
			double av=apr_eval(*x,*y);
			double errbw=fv-av;
			double errw=errbw/fv;

			sprintf(line,"%lf %lf %lf %lf %lf %lf\n",*x,*y,fv,av,errbw,errw);

			strcat(buf,line);

			*x+=dx;
		}

		*y+=dy;
	}

	return buf;
}