#ifndef DQUAD_H
#define DQUAD_H


#include "err.h"
#include "feval/eval.h"

//kolejno f(x,y), g(x,y), p(x,y)
double dblquad(const char *s1,double (*g)(double x,double y),double a,double b,double c,double d,int n)
{
	CEval<double> f;

	double *fpx,*fpy;
	f.AddVar("x",0);
	f.AddVar("y",0);

	fpx=f.GetVarPtr("x");
	fpy=f.GetVarPtr("y");


	if (!f.Set(s1)) return 0;
	n--;
	if (n==0) return 0;

	double hx=(b-a)/n;
	double hy=(d-c)/n;

	int i,j;
	double x,y=c;

	double sum=0;

	for (j=0; j<=n; j++)
	{
		y=c+hy*j;

		*fpy=y;

		for (i=0; i<=n; i++)
		{
			x=a+hx*i;

			*fpx=x;

			double fv=f()*g(x,y);
			if (IS_INV(fv)) fv=0;

			double cij=1+(i>0 && i<n)+(j>0 && j<n)+((i>0 && i<n && j>0 && j<n));

			//printf("% 0.2lf % 0.2lf % 0.2lf\n",x,y,cij);

			sum+=cij*fv;
		}
	}

	sum*=hx*hy/4;

	return sum;
}

#endif