//unit.h

#ifndef _UNIT_H_
#define _UNIT_H_

//deklaracje


//!Klasa bazowa, reprezentujaca pojedynczy wezel drzewa (unit)
template<class Type>
class CBaseUnit
{
public:
	virtual ~CBaseUnit() {}
	virtual Type operator()()=0;
};


//!Zwraca stala wartosc
template<class Type>
class CValUnit:public CBaseUnit<Type>
{
private:
	Type val;
public:
	//konstruktor wymusza zdefiniowanie wszystkich pol
	CValUnit(Type a=0) {val=a;}

	Type operator()() {return val;}
};


//!Zwraca zmienna
template<class Type>
class CVarUnit:public CBaseUnit<Type>
{
private:
	Type *var;
public:
	//konstruktor wymusza zdefiniowanie wszystkich pol
	CVarUnit(Type *a=0) {var=a;}

	Type operator()() {return *var;}
};


//!Zwraca wartosc funkcji 1-arg
template<class Type>
class C1OpUnit:public CBaseUnit<Type>
{
public: typedef Type (*TFunc)(Type);
private:
	CBaseUnit<Type> *a1;
	TFunc reffunc;
public:
	//konstruktor wymusza zdefiniowanie wszystkich pol
	C1OpUnit(CBaseUnit<Type> *arg1,TFunc f)
	{
		a1=arg1;
		reffunc=f;
	}
	~C1OpUnit() 
	{
		delete a1;
	}

	Type operator()() {return reffunc((*a1)());}
};


//!Zwraca wartosc funkcji 2-arg
template<class Type>
class C2OpUnit:public CBaseUnit<Type>
{
public: typedef Type (*TFunc)(Type,Type);
private:
	CBaseUnit<Type> *a1,*a2;
	TFunc reffunc;
public:
	//konstruktor wymusza zdefiniowanie wszystkich pol
	C2OpUnit(CBaseUnit<Type> *arg1,CBaseUnit<Type> *arg2,TFunc f)
	{
		a1=arg1;
		a2=arg2;
		reffunc=f;
	}
	~C2OpUnit() 
	{
		delete a2; 
		delete a1;
	}

	Type operator()() {return reffunc((*a1)(),(*a2)());}
};

#endif //_UNIT_H_
